Index: COPYING
===================================================================
--- COPYING	(revision a50991a37f71841fab5f2872e18f82a2867dc656)
+++ COPYING	(revision 978443847aa752b7004dec58e57e97bfbd43cab4)
@@ -4,5 +4,5 @@
      Authors: W. Decker, G.-M. Greuel, G. Pfister, H. Schoenemann
 
-                        Copyright (C) 1986-2015
+                        Copyright (C) 1986-2016
 
 
Index: Singular/COPYING
===================================================================
--- Singular/COPYING	(revision a50991a37f71841fab5f2872e18f82a2867dc656)
+++ Singular/COPYING	(revision 978443847aa752b7004dec58e57e97bfbd43cab4)
@@ -7,5 +7,5 @@
            Authors: G.-M. Greuel, G. Pfister, H. Schoenemann
 
-                        Copyright (C) 1986-2015
+                        Copyright (C) 1986-2016
 
 
Index: Singular/LIB/COPYING
===================================================================
--- Singular/LIB/COPYING	(revision a50991a37f71841fab5f2872e18f82a2867dc656)
+++ Singular/LIB/COPYING	(revision 978443847aa752b7004dec58e57e97bfbd43cab4)
@@ -8,5 +8,5 @@
            Authors: see the header of the libraries or the list below
 
-                        Copyright (C) 1986-2015
+                        Copyright (C) 1986-2016
 
 This directory contains all Singular libraries,
Index: Singular/LIB/all.lib.tmpl
===================================================================
--- Singular/LIB/all.lib.tmpl	(revision a50991a37f71841fab5f2872e18f82a2867dc656)
+++ Singular/LIB/all.lib.tmpl	(revision 978443847aa752b7004dec58e57e97bfbd43cab4)
@@ -1,4 +1,4 @@
 ///////////////////////////////////////////////////////////////////////////////
-version="version all.lib 4.0.2.0 Feb_2015 ";
+version="version all.lib 4.0.3.0 Jan_2016 ";
 category = "General purpose";
 info="
Index: Singular/table.h
===================================================================
--- Singular/table.h	(revision a50991a37f71841fab5f2872e18f82a2867dc656)
+++ Singular/table.h	(revision 978443847aa752b7004dec58e57e97bfbd43cab4)
@@ -1084,4 +1084,7 @@
   { "ring",        0, RING_CMD ,          RING_CMD},
   { "ringlist",    0, RINGLIST_CMD ,      CMD_1},
+  #ifdef SINGULAR_4_1
+  { "ring_list",   0, RING_LIST_CMD ,     CMD_1},
+  #endif
   { "rvar",        0, IS_RINGVAR ,        CMD_1},
   { "sba",         0, SBA_CMD ,           CMD_123},
Index: Singular/tok.h
===================================================================
--- Singular/tok.h	(revision a50991a37f71841fab5f2872e18f82a2867dc656)
+++ Singular/tok.h	(revision 978443847aa752b7004dec58e57e97bfbd43cab4)
@@ -133,4 +133,7 @@
   RESULTANT_CMD,
   RINGLIST_CMD,
+  #ifdef SINGULAR_4_1
+  RING_LIST_CMD,
+  #endif
   ROWS_CMD,
   SIMPLEX_CMD,
Index: configure.ac
===================================================================
--- configure.ac	(revision a50991a37f71841fab5f2872e18f82a2867dc656)
+++ configure.ac	(revision 978443847aa752b7004dec58e57e97bfbd43cab4)
@@ -1,4 +1,4 @@
-AC_INIT([singular], [4.0.2], [singular@mathematik.uni-kl.de])
-AC_DEFINE([VERSION_DATE],["Feb 2015"],[release date])
+AC_INIT([singular], [4.0.3], [singular@mathematik.uni-kl.de])
+AC_DEFINE([VERSION_DATE],["Jan 2016"],[release date])
 
 _AC_SRCDIRS(["$ac_dir"])
Index: emacs/COPYING
===================================================================
--- emacs/COPYING	(revision a50991a37f71841fab5f2872e18f82a2867dc656)
+++ emacs/COPYING	(revision 978443847aa752b7004dec58e57e97bfbd43cab4)
@@ -8,5 +8,5 @@
            Authors: G.-M. Greuel, G. Pfister, H. Schoenemann
 
-                        Copyright (C) 1986-2015
+                        Copyright (C) 1986-2016
 
 
Index: factory/COPYING
===================================================================
--- factory/COPYING	(revision a50991a37f71841fab5f2872e18f82a2867dc656)
+++ factory/COPYING	(revision 978443847aa752b7004dec58e57e97bfbd43cab4)
@@ -8,5 +8,5 @@
   Authors: G.-M. Greuel, R. Stobbe, J. Schmidt, M. Lee,
            G. Pfister, H. Schoenemann
-                        Copyright (C) 1991-2015
+                        Copyright (C) 1991-2016
 
   Characteristic sets and factorization over algebraic function fields:
Index: factory/configure.ac
===================================================================
--- factory/configure.ac	(revision a50991a37f71841fab5f2872e18f82a2867dc656)
+++ factory/configure.ac	(revision 978443847aa752b7004dec58e57e97bfbd43cab4)
@@ -13,5 +13,5 @@
 # - initialisation.
 #
-AC_INIT([factory], [4.0.2])
+AC_INIT([factory], [4.0.3])
 AC_CONFIG_SRCDIR(canonicalform.cc)
 AC_CONFIG_MACRO_DIR([../m4])
Index: kernel/COPYING
===================================================================
--- kernel/COPYING	(revision a50991a37f71841fab5f2872e18f82a2867dc656)
+++ kernel/COPYING	(revision 978443847aa752b7004dec58e57e97bfbd43cab4)
@@ -7,5 +7,5 @@
            Authors: G.-M. Greuel, G. Pfister, H. Schoenemann
 
-                        Copyright (C) 1986-2015
+                        Copyright (C) 1986-2016
 
 
Index: kernel/mod2.h
===================================================================
--- kernel/mod2.h	(revision a50991a37f71841fab5f2872e18f82a2867dc656)
+++ kernel/mod2.h	(revision 978443847aa752b7004dec58e57e97bfbd43cab4)
@@ -94,5 +94,5 @@
 #define SINGULAR_VERSION 4100
 #else
-#define SINGULAR_PATCHLEVEL 2
+#define SINGULAR_PATCHLEVEL 0
 #define SINGULAR_VERSION ((SINGULAR_MAJOR_VERSION*1000 + SINGULAR_MINOR_VERSION*100 + SINGULAR_SUB_VERSION*10)+SINGULAR_PATCHLEVEL)
 #endif
Index: libpolys/COPYING
===================================================================
--- libpolys/COPYING	(revision a50991a37f71841fab5f2872e18f82a2867dc656)
+++ libpolys/COPYING	(revision 978443847aa752b7004dec58e57e97bfbd43cab4)
@@ -7,5 +7,5 @@
            Authors: G.-M. Greuel, G. Pfister, H. Schoenemann
 
-                        Copyright (C) 1986-2015
+                        Copyright (C) 1986-2016
 
 
Index: libpolys/configure.ac
===================================================================
--- libpolys/configure.ac	(revision a50991a37f71841fab5f2872e18f82a2867dc656)
+++ libpolys/configure.ac	(revision 978443847aa752b7004dec58e57e97bfbd43cab4)
@@ -1,3 +1,3 @@
-AC_INIT([libpolys], [4.0.2])
+AC_INIT([libpolys], [4.0.3])
 
 AC_CONFIG_MACRO_DIR([../m4])
Index: make_tar.sh
===================================================================
--- make_tar.sh	(revision a50991a37f71841fab5f2872e18f82a2867dc656)
+++ make_tar.sh	(revision 978443847aa752b7004dec58e57e97bfbd43cab4)
@@ -1,4 +1,4 @@
 #!/bin/sh
-VERSION=4.0.2p3
+VERSION=4.0.3
 export VERSION
 
@@ -29,4 +29,5 @@
 command rm -rf singular-$VERSION/logo  singular-$VERSION/standalone.test  singular-$VERSION/templates  singular-$VERSION/tests
 cp redhat/singular.spec singular-$VERSION/redhat/singular.spec
+cp /tmp/wawa-i/share/singular/LIB/all.lib  singular-$VERSION/Singular/LIB/.
 tar cf singular-$VERSION.tar singular-$VERSION
 gzip -9 -f singular-$VERSION.tar
Index: resources/configure.ac
===================================================================
--- resources/configure.ac	(revision a50991a37f71841fab5f2872e18f82a2867dc656)
+++ resources/configure.ac	(revision 978443847aa752b7004dec58e57e97bfbd43cab4)
@@ -1,3 +1,3 @@
-AC_INIT([resources], [4.0.2])
+AC_INIT([resources], [4.0.3])
 
 AC_CONFIG_MACRO_DIR([../m4])